include	c:\cxpl\codes;
string 0;

def LOBUFFSZ=4*1024;

char CmdLine($80);
int CpuRegs, DosBuff, NumArgs;
int ModeProp(4);

char FrmBuff;
int FrmW,FrmH,FrmScnLn,FrmBpp;
int Pal(256);
int DelayTime;

int StopPlay;
	

func StrLen(Str);
char Str;
int Sz;
begin
	Sz:=0;	
	while Str(Sz)#0 do Sz:=Sz+1;	
	return Sz;
end;

func FileSeek(Handle,Offset,Origin);
int Handle,Offset,Origin;
begin
	CpuRegs(0):=$4200 ! Origin;
	CpuRegs(1):=Handle;
	CpuRegs(2):=Offset>>16;
	CpuRegs(3):=Offset & $ffff;
	SoftInt($21);
	if CpuRegs(7)=false then return ((CpuRegs(3)<<16) + (CpuRegs(0) & $ffff))
	else return -1;

end;


proc ParseCmdLine;				
int I, J;
begin	
	I:=0;
	J:=0;
	NumArgs:=0;
	Blit(CpuRegs(11),$81,CpuRegs(12),CmdLine,$7f);
	while CmdLine(I)=$20 ! CmdLine(I)=$9 do I:=I+1;
	if CmdLine(I)=$d then 
	begin		
		CmdLine(0):=0;
		return;
	end;
	loop 
	begin
		repeat
		begin
			CmdLine(J):=CmdLine(I);
			J:=J+1;
			I:=I+1;
		end
		until CmdLine(I)=$20 ! CmdLine(I)=$9 ! CmdLine(I)=$d;
		
		NumArgs:=NumArgs+1;
		CmdLine(J):=0;
		J:=J+1;
		if CmdLine(I)=$d then return;
		while CmdLine(I)=$20 ! CmdLine(I)=$9 do I:=I+1;
		if CmdLine(I)=$d then return;
	end;
end;


func GetArg(ArgNo);
int ArgNo;
int I,J;
begin
	if ArgNo>NumArgs ! NumArgs=0 then return 0;
	if ArgNo=1 then return CmdLine;
	
	I:=0;
	J:=1;
	loop
	begin
		while CmdLine(I)#0 do I:=I+1;
		I:=I+1;
		J:=J+1;
		if ArgNo=J then return CmdLine+I
	end;
	
end;

func FileOp(File,Attr);
char File;
int Attr;
begin
	Blit(CpuRegs(12),File,DosBuff,0,StrLen(File)+1);
	CpuRegs(0):=$3d00 + (Attr & $ff);
	CpuRegs(9):=DosBuff;
	CpuRegs(3):=0;
	SoftInt($21);
	if CpuRegs(7)=false then return (CpuRegs(0) & $ffff)
	else return -1;
end;


func FileRd(Handle,Buffer,Size);
int Handle;
char Buffer;
int Size;
int BuffOffs,SzRd,TotRd;
begin
	TotRd:=0;
	BuffOffs:=Buffer;
	loop begin
		if (Size>0 & Size<LOBUFFSZ) then SzRd:=Size	
		else SzRd:=LOBUFFSZ;	
		CpuRegs(0):=$3f00;
		CpuRegs(1):=Handle;
		CpuRegs(2):=SzRd;
		CpuRegs(3):=0;	
		CpuRegs(9):=DosBuff;
		SoftInt($21);		
		if CpuRegs(7)=false then 
		begin
			CpuRegs(0):=CpuRegs(0) & $ffff;
			Blit(DosBuff,0,CpuRegs(12),BuffOffs,CpuRegs(0));
			TotRd:=TotRd+CpuRegs(0);
			Size:=Size-SzRd;
			if Size=0 ! (SzRd # CpuRegs(0)) then quit;
			BuffOffs:=BuffOffs+SzRd;
		end
		else quit 
	end;
	return TotRd;	
end;


func FindMode(PicWidth,PicHeight,PicBpp);
def NUMMODES=21;
int PicWidth,PicHeight,PicBpp;
int VideoModes,I;
begin
	VideoModes:=[[$013, 320, 200, 8],
		     [$100, 640, 400, 8], 
		     [$101, 640, 480, 8],
		     [$103, 800, 600, 8],
		     [$105,1024, 768, 8],
		     [$107,1280,1024, 8],
		     [$10d, 320, 200,15],
		     [$10e, 320, 200,16],
		     [$10f, 320, 200,24],
		     [$110, 640, 480,15],
		     [$111, 640, 480,16],
		     [$112, 640, 480,24],
		     [$113, 800, 600,15],
		     [$114, 800, 600,16],
		     [$115, 800, 600,24],
		     [$116,1024, 768,15],
		     [$117,1024, 768,16],
		     [$118,1024, 768,24],
		     [$119,1280,1024,15],
		     [$11a,1280,1024,16],
		     [$11b,1280,1024,24]];
		
	for I:=0,NUMMODES-1 do
	begin
		if ((VideoModes(I,1)>=PicWidth)  & 
		    (VideoModes(I,2)>=PicHeight) & 
		    (VideoModes(I,3)=PicBpp)) then
		begin
			ModeProp(0):=VideoModes(I,0);
			ModeProp(1):=VideoModes(I,1);
			ModeProp(2):=VideoModes(I,2);
			ModeProp(3):=VideoModes(I,3);
			return true;
		end;
	end;

	return false;
end;

proc	WaitSync;			
begin
	while port($3DA) & $08 do;	
	repeat until port($3DA) & $08
end;


proc SetPal(Palette, FirstCol, LastCol, Is6bit);
int Palette, FirstCol,LastCol,Is6bit;
int I;
begin
	WaitSync;
	port($3C8):= FirstCol;
	if Is6bit=true then
	begin
		for I:=0, LastCol-FirstCol do
		begin
			port($3C9):=Palette(I);
			port($3C9):=Palette(I)>>8;
			port($3C9):=Palette(I)>>16;
		end;
	end
	else
	begin
		for I:=0, LastCol-FirstCol do
		begin
			port($3C9):=Palette(I)>>2;
			port($3C9):=Palette(I)>>10;
			port($3C9):=Palette(I)>>18;
		end;
	end
end;

proc Delay(Msec);
int Msec;
int Microsec;
begin
	
	if Msec=0 then return;
	Microsec:=Msec*1000;
	CpuRegs(0):=$8600;
	CpuRegs(2):=Microsec>>16;
	CpuRegs(3):=Microsec & $ffff;
	SOFTINT($15);
	if ((CpuRegs(7)=true) ! ((CpuRegs(0)>>8 & $ff)=$83))  then
	begin
				

	end;
end;	


func FileCl(Handle);
int Handle;
begin
	CpuRegs(0):=$3e00;
	CpuRegs(1):=Handle;
	SoftInt($21);	
	if CpuRegs(7)=false then return true
	else return false;
end;


proc SetMemB(Buffer,Value,Size);
char Buffer;
int Value,Size;
begin

asm	{
	push edi
	mov edi,Buffer
	mov al,Value
	mov ecx,Size
	mov ebx,ecx
	and ebx,3
	shr ecx,2
	or ecx,ecx
	jz @@1
	mov ah,al
	mov dx,ax
	shl eax,16
	mov ax,dx
	rep stosd
@@1:
	or ebx,ebx
	jz @@2
	mov ecx,ebx
	rep stosb
@@2:	
	pop edi
	}
end;

proc SetMemW(Buffer,Value,Size);
char Buffer;
int Value, Size;
begin

asm	{
	push edi
	mov edi,Buffer
	mov ax,Value
	mov ecx,Size
	mov ebx,ecx
	and ebx,1
	shr ecx,1
	or ecx,ecx
	jz @@3
	mov dx,ax
	shl eax,16
	mov ax,dx
	rep stosd
@@3:
	or ebx,ebx
	jz @@4
	stosw
@@4:	
	pop edi
	}
	
end;

proc ShowFrame;
begin
	Delay(DelayTime);
	WaitSync;
	Paint((ModeProp(1)-FrmW)/2,(ModeProp(2)-FrmH)/2,FrmW,FrmH,FrmBuff,FrmScnLn);
end;




func PlayFlic(FileName);
char FileName;
int Handle;
int FirstFrame;
int NumFrames;
int FramesLeft;

func RdFliSubchnk;
def FLICOLOR256=4,FLISS2=7,FLICOLOR=11,FLILC=12,FLIBLACK=13;
def FLIBRUN=15,FLICOPY=16,DATAHDRSIZE=6;   
int SubChnkBuff(DATAHDRSIZE+2);
int SubChnkID;
int Sz,DataSz;
char DataBuff;

proc DoFliPal;
int NumPackets, Index, I;
char Skip,Change;
begin
	Index:=0;
	NumPackets:=DataBuff(1)<<8+DataBuff(0);
	DataBuff:=DataBuff+2;
	for I:=0, NumPackets-1 do
	begin	
		Skip:=DataBuff(0);
		DataBuff:=DataBuff+1;
		if Skip=0 then
		begin
			DataBuff:=DataBuff+1;
			for Index:=0, 255 do
			begin
				Pal(Index):=DataBuff(2)<<16+DataBuff(1)<<8+DataBuff(0);
				DataBuff:=DataBuff+3; 
			end;
		end
		else
		begin
			Index:=Index+Skip;
			Change:=DataBuff(0);
			DataBuff:=DataBuff+1;
			for I:=0, Change-1 do
			begin
				Pal(Index):=DataBuff(2)<<16+DataBuff(1)<<8+DataBuff(0);
				DataBuff:=DataBuff+3; 
				Index:=Index+1;
			end;
		end;	
	end;
end;

proc DoFliSs2;
int DestAddr,NumLines,Opcode, Val;
int I,J,TmpInt,BuffW;
char PutSz;
begin
	NumLines:=DataBuff(1)<<8 + DataBuff(0);
	DataBuff:=DataBuff+2;
	DestAddr:=FrmBuff;
	for I:=0, NumLines-1 do
	begin
		repeat
			Opcode:=DataBuff(1)<<8 + DataBuff(0);
			DataBuff:=DataBuff+2;	
			Val:=Opcode>>14;
			case Val of
			0:
			begin
				if Opcode#0 then
				begin
					TmpInt:=DestAddr;
					for J:=0, Opcode-1 do
					begin
						TmpInt:=TmpInt+DataBuff(0);
						DataBuff:=DataBuff+1;
						PutSz:=DataBuff(0);
						DataBuff:=DataBuff+1;
						if (PutSz & $80)=$80 then
						begin
						PutSz:=-PutSz & $ff;
						BuffW:=DataBuff(1)<<8+DataBuff(0);
						SetMemW(TmpInt,BuffW,PutSz);
						DataBuff:=DataBuff+2;
						end
						else
						begin
						Blit(CpuRegs(12),DataBuff,CpuRegs(12),
						TmpInt,PutSz*2);
						DataBuff:=DataBuff+PutSz*2;
						end;
						TmpInt:=TmpInt+PutSz*2;
				
					end;
				end;
				DestAddr:=DestAddr+FrmW;
			end;
			2:DestAddr(FrmW-1):=Opcode & $ff;
			3:DestAddr:=DestAddr + ( -(Opcode ! $ffff0000) * FrmW)
			other[];
		until Val=0
	end;
end;

proc DoFliLc;
char DestAddr;
char PutSz,NumPackets;
int SkipLines,NumLines,TmpInt;
int I,J;
begin	
	SkipLines:=DataBuff(1)<<8+DataBuff(0);
	DestAddr:=FrmBuff+SkipLines*FrmW;
	NumLines:=DataBuff(3)<<8+DataBuff(2);
	DataBuff:=DataBuff+4;

	for I:=0, NumLines-1 do
	begin
		TmpInt:=DestAddr;
		NumPackets:=DataBuff(0);
		DataBuff:=DataBuff+1;
		for J:=0, NumPackets-1 do
		begin
			TmpInt:=TmpInt+DataBuff(0);
			PutSz:=DataBuff(1);
			DataBuff:=DataBuff+2;
			if (PutSz & $80)=$80 then
			begin
				PutSz:=-PutSz & $ff;
				SetMemB(TmpInt,DataBuff(0),PutSz);
				DataBuff:=DataBuff+1;
			end
			else
			begin
				
				Blit(CpuRegs(12),DataBuff,CpuRegs(12),TmpInt,PutSz);
				DataBuff:=DataBuff+PutSz;
				
			end;
			TmpInt:=TmpInt+PutSz;
		
		end;
		DestAddr:=DestAddr+FrmW;
	end;

end;

proc DoFliBrun;
int I,J;
char DestAddr;
char PutSz;
begin
	
	DestAddr:=FrmBuff;
	for I:=0, FrmH-1 do
	begin 
		J:=0;
		DataBuff:=DataBuff+1;
		while J<FrmW do
		begin
			PutSz:=DataBuff(0);
			DataBuff:=DataBuff+1;
			if (PutSz & $80)=$80 then
			begin
			
				PutSz:=-PutSz & $ff;
				Blit(CpuRegs(12),DataBuff,CpuRegs(12),DestAddr,PutSz);
				DataBuff:=DataBuff+PutSz;
			end
			else
			begin
				SetMemB(DestAddr,DataBuff(0),PutSz);
				DataBuff:=DataBuff+1;
			end;
			
			DestAddr:=DestAddr+PutSz;
			J:=J+PutSz;
		end;
		
	end;

end;

begin	\RdFliSubChnk
	if FileRd(Handle,SubChnkBuff,DATAHDRSIZE)#DATAHDRSIZE then return -1;
	Sz:=SubChnkBuff(0);
	SubChnkID:=SubChnkBuff(1) & $ffff;
	DataSz:=Sz-DATAHDRSIZE;
	Trap(false);
	DataBuff:=Reserve(DataSz);
	if GetErr#0 then 
	begin
		Trap(true);
		return -1;
	end;
	
	if FileRd(Handle,DataBuff,DataSz)#DataSz then return -1;
	
	case SubChnkID of
		FLICOLOR: 
		begin
			DoFliPal;
			SetPal(Pal,0,255,true);
		end;
		FLICOLOR256: 
		begin
			DoFliPal;
			SetPal(Pal,0,255,false);
		end;
		FLISS2: 
		begin
			DoFliSS2;
			ShowFrame;
		end;
		FLILC:
		begin 
			DoFliLc;
			ShowFrame;
		end;
		FLIBLACK:
		begin
			SetMemB(FrmBuff,0,FrmScnLn*FrmH);
			ShowFrame;
		end;
		FLIBRUN:
		begin 
			DoFliBrun;
			ShowFrame;
		end;
		FLICOPY: 
		begin	
			Blit(CpuRegs(12),DataBuff,CpuRegs(12),FrmBuff,FrmScnLn*FrmH);
			ShowFrame	
		end
	other [];
	return Sz;

end;	\RdFliSubChnk

func RdFliChunk;	\RdFliChunk
def CHNKID=$f1fa,CHNKHDRSIZE=16;
int ChnkBuff(CHNKHDRSIZE);
int ChnkSz,SubChnkSz,RdSz;
int SubChnksNo;
int I;
begin	

	if FileRd(Handle,ChnkBuff,CHNKHDRSIZE)#CHNKHDRSIZE then return false;
	ChnkSz:=ChnkBuff(0)-CHNKHDRSIZE;
	RdSz:=0;

	if ((ChnkBuff(1) & $ffff)=CHNKID) then
	begin	
		SubChnksNo:=ChnkBuff(1)>>16;
		if SubChnksNo=0 then Delay(DelayTime)
		else
		begin
			for I:=0, SubChnksNo-1 do
			begin
				SubChnkSz:=RdFliSubChnk;
				if SubChnkSz=-1 then return false;
				RdSz:=RdSz+SubChnkSz;
			end;
		end;
		FramesLeft:=FramesLeft-1;
	end;
	
	if ChkKey=true then 
	begin
		Chin(1);
		StopPlay:=true;
	end;
	
	
	if ChnkSz#RdSz then 
		FileSeek(Handle,ChnkSz-RdSz,1);
	
	return true;

end;	\END RdFliChunk

func RdFliHdr;
def FLIID=$af11,FLCID=$af12,FLIHDRSIZE=128;
int HdrBuff(FLIHDRSIZE);
int FlicID;
begin
	if FileRd(Handle,HdrBuff,FLIHDRSIZE)#FLIHDRSIZE then return false;
	FlicID:=HdrBuff(1) & $ffff;
	if ((FlicID#FLIID) & (FlicID#FLCID)) then return false;
	NumFrames:=HdrBuff(1)>>16;
	FrmW:=HdrBuff(2) & $ffff;
	FrmH:=HdrBuff(2)>>16;
	FrmBpp:=HdrBuff(3) & $ffff;
	if FrmBpp=0 then FrmBpp:=8; \for some buggy fli
	if FrmBpp#8  then return false;
	DelayTime:=HdrBuff(4);
	if FlicID=FLIID then 
	begin
		DelayTime:= DelayTime * 14;
		FirstFrame:=FLIHDRSIZE;
	end
	else 
	begin
		FirstFrame:=HdrBuff(20);
		if FirstFrame=0 then FirstFrame:=FLIHDRSIZE;
	end;
	return true;
end;

begin	\PlayFli
	Handle:=FileOp(FileName,0);
	if Handle=-1 then return false;
	if RdFliHdr=false then 
	begin
		
		FileCl(Handle);
		return false;
	end;

	FrmScnLn:=FrmW;

	Trap(false);
	
\	Pal:=Reserve(256);
	FrmBuff:=Reserve(FrmScnLn*FrmH);
	

	if GetErr#0 then
	begin
		Trap(true);
		FileCl(Handle);
		return false;
	end;	

	if FindMode(FrmW,FrmH,FrmBpp)=false then
	begin
		Trap(true);
		FileCl(Handle);
		return false;
	end;	
	
	SetVid(ModeProp(0));
	if GetErr#0 then 
	begin
		Trap(true);
		FileCl(Handle);		
		return false;
	end;
	Trap(true);
	
	StopPlay:=false;
	repeat 
	begin
		
		FileSeek(Handle,FirstFrame,0);
		FramesLeft:=NumFrames;	
		while ((FramesLeft#0) & (StopPlay=false)) do
			if RdFliChunk=false then StopPlay:=true;
		
	end
	until(StopPlay=true);
	
	SetVid($3);
	FileCl(Handle);
	return true;

end;	\END PlayFli

begin	\Main
	CpuRegs:=GetReg;
	ParseCmdLine;
	if NumArgs=0 then 
	begin
		Text(0,"No file name passed as argument...");
		CrLf(0);
		exit(-1);
	end;
	
	DosBuff:=Malloc(LOBUFFSZ/16);	
	if PlayFlic(GetArg(1))=false then
	begin
		Text(0,"Error...");
		CrLf(0);
		Release(DosBuff);
		exit(-1);
	end
	else	Release(DosBuff);
end;	\END Main
